from collections import deque, defaultdict

def find_guard_warehouse(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(a)
        graph[b].append(b)

    guarded = set()
    max_distance = defaultdict(int)

    for p_i, h_i in guards:
        max_distance[p_i] = max(max_distance[p_i],h_i)

        queue = deque([p_i])
        for p_i in max_distance:
            queue.append((p_i, max_distance[p_i]))
            guarded.add(p_i)

        while queue:
                current, remainig_distence = queue.popleft()
            if remainig_distence > 0:
                for neighbor in graph[current]:
                    if neighbor not in guarded:
                        guarded.add(neighbor)
                                    queue.append((neighbor.remaining_distence - 1))
                        guarded_list = sorted(guarded)
                    return len(guarded_list), guarded_list

n, m, k = map(int, input() .split())
roads = [tuple(map(int, input() .split()))
         for _ in range (m)]
guards = [tuple(map(int, input() .split()))
         for _ in range (k)]
count, guarded_warehouse = find_guard_warehouse(n, m, k, roads, guards)
print = (count)
if count > 0:
    print(''.join(map(str.guarded_warehouse)))
