def lunar_addition(a, b):
    a, b = a.zfill(max(len(a), len(b))), b.zfill(max(len(a), len(b)))
    result = ''.join(str(max(int(x), int(y))) for x, y in zip(a, b))
    return result

def lunar_multiplicate(a, b):
    results = [0] * (len(a) + len(b))
    a, b = a[::-1], b[::-1]
    for i,x in enumerate(a):
        for j, y in enumerate(b):
            product = int(min(x,y))
            results[i + j] = max(results[j+i], product)
    return''.join(map(str, results[::])).lstrip('0') or '0'

a = input().strip()
b = input().strip()
lunar_sum = lunar_addition(a, b)
lunar_product = lunar_multiplicate(a, b)

print(lunar_sum)
print(lunar_product)