from collections import deque, defaultdict

def find_guard_warehouse(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append
        graph[b].append
    guarded = set()
    for p_i, h_i in guards:
        queue = deque([p_i])
        visited = {p_i}
        distance = 0
        while queue and distance < h_i:
            for _ in range(len(queue)):
                current = queue.popleft()
                guarded.add(current)
                for neighbor in graph[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append(neighbor)
                        distance += 1
                        guarded_list = sorted(guarded)
                        return len(guarded_list), guarded_list
n, m, k = map(int, input() .split())
roads = [tuple(map(int, input() .split()))
         for _ in range (m)]
guards = [tuple(map(int, input() .split()))
         for _ in range (k)]
count, guarded_warehouse = find_guard_warehouse(n, m, k, roads, guards)
print = (count)
if count > 0:
    print(''.join(map(str.guarded_warehouse)))
